/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-rail-user-queue-manager-0.0.2-0raring-20150508-1711/msg/UserStatus.msg
 *
 */


#ifndef RAIL_USER_QUEUE_MANAGER_MESSAGE_USERSTATUS_H
#define RAIL_USER_QUEUE_MANAGER_MESSAGE_USERSTATUS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace rail_user_queue_manager
{
template <class ContainerAllocator>
struct UserStatus_
{
  typedef UserStatus_<ContainerAllocator> Type;

  UserStatus_()
    : user_id(0)
    , wait_time()
    , time_left()  {
    }
  UserStatus_(const ContainerAllocator& _alloc)
    : user_id(0)
    , wait_time()
    , time_left()  {
    }



   typedef uint32_t _user_id_type;
  _user_id_type user_id;

   typedef ros::Duration _wait_time_type;
  _wait_time_type wait_time;

   typedef ros::Duration _time_left_type;
  _time_left_type time_left;




  typedef boost::shared_ptr< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct UserStatus_

typedef ::rail_user_queue_manager::UserStatus_<std::allocator<void> > UserStatus;

typedef boost::shared_ptr< ::rail_user_queue_manager::UserStatus > UserStatusPtr;
typedef boost::shared_ptr< ::rail_user_queue_manager::UserStatus const> UserStatusConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rail_user_queue_manager::UserStatus_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rail_user_queue_manager

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'rail_user_queue_manager': ['/tmp/buildd/ros-hydro-rail-user-queue-manager-0.0.2-0raring-20150508-1711/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dbdddac94aedaa515185f9c47c1803ef";
  }

  static const char* value(const ::rail_user_queue_manager::UserStatus_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xdbdddac94aedaa51ULL;
  static const uint64_t static_value2 = 0x5185f9c47c1803efULL;
};

template<class ContainerAllocator>
struct DataType< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rail_user_queue_manager/UserStatus";
  }

  static const char* value(const ::rail_user_queue_manager::UserStatus_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "uint32 user_id      # The user ID\n\
duration wait_time  # Estimated wait time\n\
duration time_left  # Time left for active user\n\
";
  }

  static const char* value(const ::rail_user_queue_manager::UserStatus_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.user_id);
      stream.next(m.wait_time);
      stream.next(m.time_left);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct UserStatus_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rail_user_queue_manager::UserStatus_<ContainerAllocator>& v)
  {
    s << indent << "user_id: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.user_id);
    s << indent << "wait_time: ";
    Printer<ros::Duration>::stream(s, indent + "  ", v.wait_time);
    s << indent << "time_left: ";
    Printer<ros::Duration>::stream(s, indent + "  ", v.time_left);
  }
};

} // namespace message_operations
} // namespace ros

#endif // RAIL_USER_QUEUE_MANAGER_MESSAGE_USERSTATUS_H
